/*
	xVideo Overlay Bitmap Demo
	Copyright (c) 2010-2011 Cristea Aurel Ionut.
*/

#include <windows.h>
#include <commctrl.h>
#include <stdio.h>
#include "xVideo.h"

HWND win = NULL;
xVideo_VideoBitmap vidBMP;
HSTREAM chan = 0;			// channel handle
HDC imgHDC = NULL; //hdc;
HINSTANCE hI;


OPENFILENAME ofn;

// display error messages
void Error(const char *es)
{
	char mes[200];
	sprintf(mes,"%s\n(error code: %d)",es,xVideo_ErrorGetCode());
	MessageBox(win,mes,0,0);
}
 

HDC CreateBitmapHDC()
{
	if(imgHDC) return imgHDC; 
	HBITMAP g_hbmBall = NULL;
    g_hbmBall = LoadBitmap(GetModuleHandle(NULL), MAKEINTRESOURCE(102));
    if(g_hbmBall == NULL)
	{
		MessageBox(win, "Could not load xVideo BMP", "Error", MB_OK | MB_ICONEXCLAMATION);
		return NULL;
	}

	BITMAP bm;
    PAINTSTRUCT ps;
    HDC hdcMem = CreateCompatibleDC(NULL);
    SelectObject(hdcMem, g_hbmBall);

    GetObject(g_hbmBall, sizeof(bm), &bm);
	imgHDC = hdcMem;
	return hdcMem;
}

#define MESS(id,m,w,l) SendDlgItemMessage(win,id,m,(WPARAM)(w),(LPARAM)(l))


BOOL CALLBACK dialogproc(HWND h,UINT m,WPARAM w,LPARAM l)
{
	switch (m) {
		case WM_COMMAND:
			switch (LOWORD(w)) {
				case IDCANCEL:
					DestroyWindow(h);
					break;
				case 10:
					{
						char file[MAX_PATH]="";
						ofn.lpstrFilter="playable files\0*.wmv;*.avi;*mp4;*.mkv;*.mp3;*.mp2;*.mp1;*.ogg;*.wav;*.aif\0All files\0*.*\0\0";
						ofn.lpstrFile=file;
						if (GetOpenFileName(&ofn)) {
						
						
							xVideo_StreamFree(chan);
                            if(!(chan = xVideo_StreamCreateFile(file,0,h,0))){
								MESS(10,WM_SETTEXT,0,"click here to open a file...");
								Error("Can't play the file");
								break;
							}
							MESS(10,WM_SETTEXT,0,file);
							xVideo_ChannelSetWindow(chan,0,GetDlgItem(win, 321));
							xVideo_ChannelPlay(chan);
							{
								
								vidBMP.alphavalue = 1.0f;
								if(imgHDC == NULL) imgHDC = CreateBitmapHDC();
								vidBMP.bmp = imgHDC;
								vidBMP.inBottom = 297;
								vidBMP.inRight = 406;
								vidBMP.inLeft = 0;
								vidBMP.inTop = 0;
								vidBMP.outBottom = 0.5;
								vidBMP.outLeft = 0;
								vidBMP.outRight = 0.5;
								vidBMP.outTop = 0;
								vidBMP.visible = true;
								vidBMP.transColor = RGB(255, 255, 255);
								xVideo_ChannelOverlayBMP(chan,&vidBMP);
							}
						}
					}
					break;
			}
			break;

		

		case WM_INITDIALOG:
			win=h;
			memset(&ofn,0,sizeof(ofn));
			ofn.lStructSize=sizeof(ofn);
			ofn.hwndOwner=h;
			ofn.nMaxFile=MAX_PATH;
			ofn.Flags=OFN_HIDEREADONLY|OFN_EXPLORER;
		    xVideo_Init(win,0);
			return 1;

		case WM_DESTROY:
			xVideo_Free();
			break;
	}
	return 0;
}

int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,LPSTR lpCmdLine, int nCmdShow)
{
 
	{ // enable trackbar support
		INITCOMMONCONTROLSEX cc={sizeof(cc),ICC_BAR_CLASSES};
		InitCommonControlsEx(&cc);
	}
    hI = hInstance;
	DialogBox(hInstance,(char*)1000,0,&dialogproc);
    
	return 0;
}
