{
  xVideo 1.2: Delphi Overlay Text Demo sample
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,xVideo, ComCtrls,ExtDlgs,
  XPMan, Menus;
  type
  TFormPlayer = class(TForm)
    sc: TScrollBar;
    Panel1: TPanel;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    XPManifest1: TXPManifest;
    OpenDialog: TOpenDialog;
    Button10: TButton;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    AspectRatio1: TMenuItem;
    N431: TMenuItem;
    N1691: TMenuItem;
    Button1: TButton;
    Image1: TImage;
    Timer2: TTimer;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    Timer1: TTimer;
    Memo1: TMemo;
    Button2: TButton;
    Panel2: TPanel;
    procedure Button10Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState; MousePos:
        TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState; MousePos:
        TPoint; var Handled: Boolean);
    procedure FormResize(Sender: TObject);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlayer : TFormPlayer;
  chan       : HSTREAM;
  paused: boolean;
  rect1,rect2 : TRECT;
  struct: xVideo_VideoBitmap;
  alphavalue : Integer;
  sign : Integer;
  FTopPosition:Integer;
  FCredits:TStringList;
  Bitmap:TBitmap;
  info: xVideo_ChannelInfo;
implementation

{$R *.dfm}
function GetFiltersCallback(Filter : Pointer; FilterName: PCHAR;pp:BOOL;user:Pointer)  : BOOL; stdcall;
var
 item: TmenuItem;
begin
 item:= Tmenuitem.Create(FormPlayer.popupmenu1);
 item.Caption:=filtername;
 if pp=false then item.Enabled:=false;
 FormPlayer.PopupMenu1.Items.Items[0].Add(item);
 result:=true;
end;

procedure DrawText(const Canvas: TCanvas; const X, Y: Integer;
  const Text: string);
var
  OldBkMode: Integer;  // stores previous background mode
begin
  OldBkMode := SetBkMode(Canvas.Handle, TRANSPARENT);
  BeginPath(Canvas.Handle);
  Canvas.TextOut(X, Y, Text);
  EndPath(Canvas.Handle);
  StrokeAndFillPath(Canvas.Handle);
  SetBkMode(Canvas.Handle, OldBkMode);
end;


procedure TFormPlayer.Button10Click(Sender: TObject);
var
  file1: String;
  sz: TSIZE;

begin
   OpenDialog.Title  := 'Open Files';
   OpenDialog.Filter := 'All files|*.*';
   if chan<>0 then
   begin
    xVideo_StreamFree(chan);
    chan:=0;
   end;
   if not OpenDialog.Execute then exit;
   file1:=opendialog.FileName;
   Chan :=xVideo_StreamCreateFile(PChar(file1),0,panel1.Handle,0);
   if chan<>0 then
   begin
    xVideo_ChannelSetWindow(chan,0,panel1.Handle);
    sc.max:=round(xVideo_ChannelGetLength(chan,xVideo_POS_SEC));

     ZeroMemory(@struct,sizeof(struct));
     struct.visible := 1;
     struct.alphavalue := 0.9;
     struct.transcolor := clwhite;
     xVideo_ChannelGetInfo(chan,@info);
     sz.cx :=  info.Width;//.Picture.Bitmap.Width;
     sz.cy :=  info.Height;
     struct.inBottom :=  sz.cy;
     struct.inLeft := 0;
     struct.inTop :=0;
     struct.inRight := sz.cx;
     struct.outLeft := 0;
     struct.outTop := 0;
     struct.outRight := 1.0;
     struct.outBottom := 1.0;
     xVideo_ChannelOverlayBMP(chan,@struct);
     xVideo_ChannelAddWindow(chan,panel2.Handle);
     Button5Click(Sender);
     FormPlayer.PopupMenu1.Items.Items[0].Clear;
     xVideo_ChannelGetConnectedFilters(chan,@GetFiltersCallback,nil);

  end;
end;

procedure TFormPlayer.Button1Click(Sender: TObject);
begin
   if(struct.visible >=1) then struct.visible := 0 else struct.visible := 1;
   xVideo_ChannelOverlayBMP(chan,@struct);
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
begin
 paused:=false;
 doublebuffered:=true;
 xVideo_Init(handle,0);
 xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
 xVideo_SetConfig(xVideo_WindowLessHandle,panel1.Handle);
 alphavalue  := 100;
 FCredits := TStringList.Create;
 fcredits.AddStrings(memo1.Lines);
 FTopPosition := 0;
end;


procedure TFormPlayer.Button5Click(Sender: TObject);
begin
 if(paused=true)then paused:=true;
 xVideo_ChannelPlay(chan);
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
begin
if(paused=false) then
begin
  xVideo_ChannelPause(chan);
  paused:=true;
end else
 begin
 xVideo_ChannelPlay(chan);
 paused:=false;
 end;
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
begin
 xVideo_ChannelStop(chan);
end;

procedure TFormPlayer.CheckBox1Click(Sender: TObject);
begin
 if(checkbox1.Checked) then timer2.Enabled := true else timer2.Enabled := false;
end;

procedure TFormPlayer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 xVideo_Free;
end;

procedure TFormPlayer.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
    MousePos: TPoint; var Handled: Boolean);
begin
FTopPosition := FTopPosition - 5;
end;

procedure TFormPlayer.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
    MousePos: TPoint; var Handled: Boolean);
begin
   FTopPosition := FTopPosition + 5;
end;

procedure TFormPlayer.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
begin
 xVideo_ChannelSetPosition(chan,sc.position,xVideo_POS_SEC);
end;

procedure TFormPlayer.Button2Click(Sender: TObject);
begin
   if chan<>0 then
   begin
    xVideo_StreamFree(chan);
    chan:=0;
   end;
   Chan :=xVideo_CaptureCreate(0,1,0,0,xVideo_CaptureVideo);
   if chan<>0 then
   begin
     xVideo_ChannelSetWindow(chan,0,panel1.Handle);
     sc.max:=round(xVideo_ChannelGetLength(chan,xVideo_POS_SEC));

     ZeroMemory(@struct,sizeof(struct));
     struct.visible := 1;
     struct.alphavalue := 0.9;
     struct.transcolor := clwhite;
     xVideo_ChannelGetInfo(chan,@info);
     struct.inBottom :=  info.Height;
     struct.inLeft := 0;
     struct.inTop :=0;
     struct.inRight := info.Width;
     struct.outLeft := 0;
     struct.outTop := 0;
     struct.outRight := 1.0;
     struct.outBottom := 1.0;
     xVideo_ChannelOverlayBMP(chan,@struct);

     Button5Click(Sender);
     FormPlayer.PopupMenu1.Items.Items[0].Clear;
     xVideo_ChannelGetConnectedFilters(chan,@GetFiltersCallback,nil);

  end;


end;

procedure TFormPlayer.FormResize(Sender: TObject);
begin
  xVideo_ChannelResizeWindow(chan,0,0,0,panel1.Width,panel1.Height);
end;

procedure TFormPlayer.Timer1Timer(Sender: TObject);
var
    i,X,Y:Integer;
begin
if(chan = 0) then exit;
    Y := (FCredits.Count)*-Canvas.TextHeight('A');
    if FTopPosition<Y then FTopPosition := info.Height;
    Bitmap := TBitmap.Create;
     try
             Bitmap.Width := info.width;
             Bitmap.Height := info.Height;


             Bitmap.Canvas.Brush.Color := RGB(192,192,192);
             Bitmap.Canvas.Font.Color := clwhite;
             Bitmap.Canvas.Font.Size := 16;//*(round(panel1.Height/512));
             Bitmap.Canvas.FillRect(RECT(0,0,info.width,info.Height));

             for i:=0 to FCredits.Count-1 do begin
                X := (info.Width - Bitmap.Canvas.TextWidth(FCredits[i])) div 2;
                Y := FTopPosition + i* Bitmap.Canvas.TextHeight(FCredits[i]);
             //  Bitmap.Canvas.TextOut(X,Y,FCredits[i]);
                Bitmap.Canvas.Font.Style := [fsBold];
                Bitmap.Canvas.Font.Size :=  16*
                 (round(info.Height/480));
                Bitmap.Canvas.Brush.Color := clWhite;  // $F0CAA6
                Bitmap.Canvas.Brush.Style := bsSolid;
                Bitmap.Canvas.Pen.Color := clBlack;
                Bitmap.Canvas.Pen.Style := psSolid;
                DrawText(Bitmap.Canvas, x, y, FCredits[i]);
             end;
            // PaintBox1.Canvas.Draw(0,0,Bitmap);
     
             struct.bmp := Bitmap.Canvas.Handle;
             struct.transcolor :=  RGB(192,192,192);
             xVideo_ChannelOverlayBMP(chan,@struct);
             Dec(FTopPosition,2);

        if Assigned(Bitmap) then Bitmap.Free;
     except;
     end;
end;
procedure TFormPlayer.Timer2Timer(Sender: TObject);
begin
  if(chan <> 0) then
  begin
   if(alphavalue>=100) then sign := -1;
   if(alphavalue<=0) then sign := 1;
   alphavalue := alphavalue +(sign * 10);
   if(alphavalue>100) then alphavalue := 100;
   if(alphavalue<0) then alphavalue :=0;
   struct.alphavalue := alphavalue/100;
   xVideo_ChannelOverlayBMP(chan,@struct);
  end;
  if chan<>0 then
  sc.Position:= round(xVideo_ChannelGetPosition(chan,xVideo_POS_SEC));
end;

procedure TFormPlayer.TrackBar1Change(Sender: TObject);
begin
  struct.alphavalue := TrackBar1.Position/100;
  xVideo_ChannelOverlayBMP(chan,@struct);
end;

end.
