{
  xVideo 1.2 Delphi Capture Example
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}



unit unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls,xVideo, mmsystem, ComCtrls, ExtCtrls, Menus;

type
  TRecorder = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Label3: TLabel;
    Button2: TButton;
    GroupBox1: TGroupBox;
    audiodev: TComboBox;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Label5: TLabel;
    Panel1: TPanel;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    procedure audiodevChange(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { Private declarations }
  public
   procedure Filters1Click(Sender: TObject);
    { Public declarations }
  end;

var
  Recorder: TRecorder;
  rec: HRECORD;
  aenc: TStringList;
  venc: TStringList;
 

implementation

{$R *.dfm}

function ProfileEnum(profile: PChar; user: Pointer): BOOL; stdcall;
begin
  Recorder.ComboBox2.Items.Add(profile);
  result := true;
end;
function ProfileEnum2(profile: PChar; user: Pointer): BOOL; stdcall;
begin
  Recorder.ComboBox3.Items.Add(profile);
  result := true;
end;
function GetDevicesCallback(DevName: PChar;guid: TGUID;user: Pointer) : BOOL; stdcall;
begin
  recorder.audiodev.Items.Add(DevName);
  result:=true;
end;

function GetVideoDevicesCallback(DevName: PChar;guid: TGUID;user: Pointer) : BOOL; stdcall;
begin
  recorder.combobox1.Items.Add(DevName);
  result:=true;
end;
function GetVideoDevicesProfiles(Profile: PChar;user: Pointer) : BOOL; stdcall;
begin
  recorder.combobox2.Items.Add(Profile);
  result:=true;
end;


procedure TRecorder.audiodevChange(Sender: TObject);
begin
 Combobox3.Items.Clear;
 xVideo_CaptureDeviceProfiles(AudioDev.ItemIndex,xVideo_CaptureAudio,@ProfileEnum2,nil);
 Combobox3.ItemIndex := 0;
end;

procedure TRecorder.FormDestroy(Sender: TObject);
begin
  Button2Click(sender);
end;
 procedure TRecorder.Filters1Click(Sender: TObject);
begin
 xVideo_ShowFilterPropertyPage(rec,popupmenu1.Items.Items[0].IndexOf(sender as Tmenuitem),handle);
end;
procedure TRecorder.Button1Click(Sender: TObject);
var
 info: xVideo_ChannelInfo;
begin
 if(rec<>0) then
 begin
  xVideo_StreamFree(rec);
  rec:=0;
 end;
 rec:=xVideo_CaptureCreate(audiodev.ItemIndex,combobox1.ItemIndex,0,0,0);
 if(rec<=0) then exit; //could not start record

 xVideo_ChannelGetInfo(rec,@info);
 xVideo_ChannelSetWindow(rec,0,panel1.Handle);
 xVideo_ChannelPlay(rec);
end;

procedure TRecorder.Button2Click(Sender: TObject);
begin
 xVideo_StreamFree(rec);
 rec:=0;
end;

procedure TRecorder.ComboBox1Change(Sender: TObject);
begin
 Combobox2.Items.Clear;
 xVideo_CaptureDeviceProfiles(Combobox1.ItemIndex,xVideo_CaptureVideo,@ProfileEnum,nil);
 Combobox2.ItemIndex := 0;
end;

procedure TRecorder.FormCreate(Sender: TObject);
begin

 xVideo_Init(Panel1.handle,0);     //Init xVideo
 audiodev.Items.Add('None');
 combobox1.Items.Add('None');
 aenc := TStringList.Create;
 venc := TStringList.Create;
 
 xVideo_CaptureGetDevices(xVideo_CaptureVideo,@GetVideoDevicesCallback,nil);  //GetVideo Devices
 xVideo_CaptureGetDevices(xVideo_CaptureAudio,@GetDevicesCallback,nil);   //GetAudio Devices
 //we have at least a audio capture device
 if audiodev.Items.Count<>0 then  audiodev.ItemIndex:=0;
 //we have at least a video capture device
 if combobox1.Items.Count<>0 then combobox1.ItemIndex:=0;

 xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
end;

end.
