unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,xVIdeo, StdCtrls, ExtCtrls, ComCtrls, Menus;

type
  TFormPlayer = class(TForm)
    Button1: TButton;
    Panel1: TPanel;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    GroupBox4: TGroupBox;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    TrackBar3: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Label7: TLabel;
    sc: TScrollBar;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    AspectRatio1: TMenuItem;
    N431: TMenuItem;
    N1691: TMenuItem;
    DVD1: TMenuItem;
    GotoMenu1: TMenuItem;
    NextChapter1: TMenuItem;
    PreviousChapter1: TMenuItem;
    Rott1: TMenuItem;
    itles1: TMenuItem;
    Timer1: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Filters1Click(Sender: TObject);
    procedure GotoMenu1Click(Sender: TObject);
    procedure NextChapter1Click(Sender: TObject);
    procedure PreviousChapter1Click(Sender: TObject);
    procedure Rott1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
  private
    procedure SetTitlesInfo();
    procedure PlayTitleClick(Sender: TObject);
    procedure PlayChapterClick(Sender: TObject);
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlayer: TFormPlayer;
  chan : HSTREAM;

implementation

uses Unit2;

{$R *.dfm}
function GetFiltersCallback(Filter : Pointer; FilterName: PCHAR;pp:BOOL;user:Pointer)  : BOOL; stdcall;
var
 item: TmenuItem;
begin
 item:= Tmenuitem.Create(FormPlayer.popupmenu1);
 item.Caption:=filtername;
 if pp=false then item.Enabled:=false;
 item.OnClick:=formplayer.Filters1Click;
 FormPlayer.PopupMenu1.Items.Items[0].Add(item);
 result:=true;
end;
procedure TFormPlayer.PlayTitleClick(Sender: TObject);
begin
 // xVideo_DVDSetProperty(chan,xVideo_DVD_TITLE,popupmenu1.Items.Items[3].IndexOf(sender as Tmenuitem)+1);
end;

procedure TFormPlayer.PlayChapterClick(Sender: TObject);
begin
  xVideo_DVDSetProperty(chan,xVideo_DVD_TITLECHAPTER,popupmenu1.Items.Items[3].Items[0].IndexOf(sender as Tmenuitem)+1);
end;

procedure TFormPlayer.SetTitlesInfo;
var
  titlecount: integer;
  I: Integer;
  item: TmenuItem;
  item2: TmenuItem;
  chapcount: Integer;
  J: Integer;
begin
  PopUpMenu1.Items.Items[3].Clear;
  titlecount:= xVideo_DVDGetProperty(Chan, xVideo_DVDTitles,0);
  if(titlecount<0) then exit;
  for I := 1 to titlecount do
  begin
    item:= Tmenuitem.Create(FormPlayer.popupmenu1);
    item.Caption:='Title '+inttostr(i);
    item.OnClick:=formplayer.PlayTitleClick;
    PopupMenu1.Items.Items[3].Add(item);
        //get the title number of chapters
    chapcount:= xVideo_DVDGetProperty(Chan, xVideo_DVDTitleChapters,i);
    for J := 1 to chapcount do
    begin
     item2:= Tmenuitem.Create(FormPlayer.popupmenu1);
     item2.Caption:='Chapter '+inttostr(J);
     item2.OnClick:=formplayer.PlayChapterClick;
     PopupMenu1.Items.Items[3].Items[i-1].Add(item2);
    end;
  end;
end;
procedure TFormPlayer.FormDestroy(Sender: TObject);
begin
 xVideo_Free()
end;

procedure TFormPlayer.Button1Click(Sender: TObject);
begin
   xVideo_SetConfig(xVideo_WindowLessHandle,Form2.Handle);// set initial video renderer Handle
   if(chan<>0) then
   begin
    xVideo_StreamFree(chan);
    chan := 0;
    form2.Hide;
   end;
   chan :=xVideo_StreamCreateDVD(nil,panel1.Handle,0);
   begin
    xVideo_ChannelStop(chan);
    sc.Max :=round( xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
    xVideo_ChannelSetWindow(chan,0,Form2.Handle);
    FormPlayer.popupmenu1.Items.Items[0].Clear;
    xVideo_ChannelGetConnectedFilters(chan,@GetFiltersCallback,nil);
    SetTitlesInfo;
    xVideo_ChannelPlay(chan);
    //sc.Max :=round( xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
    form2.Show;
  end;
end;

procedure TFormPlayer.Button5Click(Sender: TObject);
begin
 xVideo_ChannelPlay(chan);
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
begin
 xVideo_ChannelPause(chan);
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
begin
 xVideo_ChannelStop(chan);
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
begin
 xVideo_Init(Handle,0);  // Init xVideo
end;

procedure TFormPlayer.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
begin
  if ScrollCode = scEndScroll then
  begin
    xVideo_ChannelSetPosition(chan,sc.Position,xVideo_POS_SEC);
  end;
end;
procedure TFormPlayer.Filters1Click(Sender: TObject);
begin
  xVideo_ShowFilterPropertyPage(chan,popupmenu1.Items.Items[0].IndexOf(sender as Tmenuitem),handle);
end;

procedure TFormPlayer.GotoMenu1Click(Sender: TObject);
begin
 xVideo_DVDSetProperty(chan,xVideo_DVD_TITLEMENU,0);
end;

procedure TFormPlayer.NextChapter1Click(Sender: TObject);
begin
 xVideo_DVDSetProperty(chan,xVideo_DVD_NEXTCHAPTER,0);
end;

procedure TFormPlayer.PreviousChapter1Click(Sender: TObject);
begin
  xVideo_DVDSetProperty(chan,xVideo_DVD_PREVCHAPTER,0);
end;

procedure TFormPlayer.Rott1Click(Sender: TObject);
begin
 xVideo_DVDSetProperty(chan,xVideo_DVD_ROOT,0);
end;

procedure TFormPlayer.Timer1Timer(Sender: TObject);
begin
 caption := inttostr(round(xVideo_ChannelGetPosition(chan,xVideo_POS_SEC)));
end;


procedure TFormPlayer.TrackBar1Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_VOL,trackbar1.Position);
end;

procedure TFormPlayer.TrackBar3Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_PAN,trackbar3.Position);
end;

procedure TFormPlayer.TrackBar4Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_ALPHA,trackbar4.Position);
end;

procedure TFormPlayer.TrackBar5Change(Sender: TObject);
begin
  xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_RATE ,trackbar5.Position/100);
end;

end.
