unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,xVideo, StdCtrls, ExtCtrls, ComCtrls, Menus,CommonTypes,osc_vis,spectrum_vis;

type
  TFormPlayer = class(TForm)
    Button1: TButton;
    OD: TOpenDialog;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    lblBrightness: TLabel;
    lblContrast: TLabel;
    lblHUE: TLabel;
    lblSaturation: TLabel;
    trbBrightness: TTrackBar;
    trbContrast: TTrackBar;
    trbHUE: TTrackBar;
    trbSaturation: TTrackBar;
    GroupBox6: TGroupBox;
    Label10: TLabel;
    Label11: TLabel;
    Label2: TLabel;
    Label12: TLabel;
    Label3: TLabel;
    Label6: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    sc: TScrollBar;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    AspectRatio1: TMenuItem;
    N431: TMenuItem;
    N1691: TMenuItem;
    GroupBox7: TGroupBox;
    ComboBox1: TComboBox;
    GroupBox4: TGroupBox;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label13: TLabel;
    TrackBar3: TTrackBar;
    TrackBar1: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar5: TTrackBar;
    TrackBar6: TTrackBar;
    Label7: TLabel;
    Timer1: TTimer;
    CheckBox1: TCheckBox;
    GroupBox2: TGroupBox;
    Label18: TLabel;
    Label19: TLabel;
    Label20: TLabel;
    TrackBar7: TTrackBar;
    PaintFrame: TPaintBox;
    ProgressBar1: TProgressBar;
    ProgressBar2: TProgressBar;
    RadioGroup1: TRadioGroup;
    Streams1: TMenuItem;
    Video1: TMenuItem;
    Audio1: TMenuItem;
    Subtitles1: TMenuItem;
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Filters1Click(Sender: TObject);
    procedure Panel1DblClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
    procedure TrackBar6Change(Sender: TObject);
    procedure TrackBar7Change(Sender: TObject);
  private
    { Private declarations }
  public
    procedure FillVideoInfo();
    procedure SetColorRange();
    procedure SetStreamsInfo();
    procedure EnableStream(Sender: TObject);
    { Public declarations }
  end;

var
  FormPlayer: TFormPlayer;
  chan : HSTREAM;
  tempoFX: HFX; //tempo fx handle
  kar : HFX; // karaoke fx handle
  info: xVideo_ChannelInfo;
  plg: HPLUGIN;

implementation

uses VideoForm;

{$R *.dfm}
 
function GetFiltersCallback(Filter : Pointer; FilterName: PCHAR;pp:BOOL;user:Pointer)  : BOOL; stdcall;
var
 item: TmenuItem;
begin
 item:= Tmenuitem.Create(FormPlayer.popupmenu1);
 item.Caption:=filtername;
 if pp=false then item.Enabled:=false;
 item.OnClick:=formplayer.Filters1Click;
 FormPlayer.PopupMenu1.Items.Items[0].Add(item);
 result:=true;
end;

procedure TFormPlayer.EnableStream(Sender: TObject);
begin
  xVideo_ChannelEnableStream(chan,(Sender As TMenuItem).Tag);
end;
procedure TFormPlayer.SetStreamsInfo;
var
 menu: TMenuItem;
 count: Integer;
 str: xVideo_STREAMS;
 I: Integer;
begin
 Popupmenu1.Items.Items[2].Items[0].Clear;
 Popupmenu1.Items.Items[2].Items[1].Clear;
 Popupmenu1.Items.Items[2].Items[2].Clear;
 count := xVideo_ChannelStreamsCount(chan);
 if(count<=0) then exit;
 for I := 0 to count-1 do
 begin
   if(xVideo_ChannelGetStream(chan,I,@str)) then
   begin
     menu := TMenuItem.Create(PopupMenu1);
     menu.Caption := str.name;
     menu.Checked := str.enabled;
     menu.Tag := I;
     menu.OnClick := EnableStream;
     Popupmenu1.Items.Items[2].Items[str.format-1].Add(menu);
   end;
 end;
end;
procedure TFormPlayer.FillVideoInfo;

begin
  xVideo_ChannelGetInfo(chan,@info);
  label12.Caption := inttostr(info.Width);
  label2.Caption  := inttostr(info.Height);
  label6.Caption  := floattostr(info.AvgTimePerFrame);
  label15.Caption:=inttostr(info.nChannels)+' Chans, '+
                     inttostr(info.freq)+' Hz, '+
                     inttostr(info.wBits)+' Bits ';


end;
procedure TFormPlayer.SetColorRange();
var
 range: xVideo_ColorsRange;
begin

 range.typ := xVideo_ControlBrightness;
 xVideo_ChannelColorRange(chan,xVideo_ControlBrightness,@range);
 trbBrightness.Max := round(range.MaxValue * 10);
 trbBrightness.Min := round(range.MinValue * 10);
 trbBrightness.Position := round(range.DefaultValue * 10);

 range.typ := xVideo_ControlContrast;
 xVideo_ChannelColorRange(chan,xVideo_ControlContrast,@range);
 trbContrast.Max := round(range.MaxValue * 10);
 trbContrast.Min := round(range.MinValue * 10);
 trbContrast.Position := round(range.DefaultValue * 10);

 range.typ := xVideo_ControlHUE;
 xVideo_ChannelColorRange(chan,xVideo_ControlHUE,@range);
 trbHUE.Max := round(range.MaxValue * 10);
 trbHUE.Min := round(range.MinValue * 10);
 trbHUE.Position := round(range.DefaultValue * 10);

 range.typ := xVideo_ControlSaturation;
 xVideo_ChannelColorRange(chan,xVideo_ControlSaturation,@range);
 trbSaturation.Max := round(range.MaxValue * 10);
 trbSaturation.Min := round(range.MinValue * 10);
 trbSaturation.Position := round(range.DefaultValue * 10);
end;
procedure TFormPlayer.FormDestroy(Sender: TObject);
begin
 xVideo_Free()
end;

procedure TFormPlayer.Button1Click(Sender: TObject);
begin
   if(chan<>0) then
   begin
    xVideo_StreamFree(chan);
    chan := 0;
   end;
   if(od.Execute(Handle)=false) then exit;

   chan := xVideo_StreamCreateFile(PChar(od.FileName),0,panel1.Handle,{$IFDEF UNICODE}xVideo_UNICODE or {$ENDIF}xVideo_STREAM_LOOP);
   if(chan <> 0) then
   begin
    FormPlayer.sc.Max :=round( xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
    xVideo_ChannelSetWindow(chan,0,FormPlayer.Panel1.Handle);

    FormPlayer.popupmenu1.Items.Items[0].Clear;
    xVideo_ChannelGetConnectedFilters(chan,@GetFiltersCallback,nil);
    FillVideoInfo;
    SetColorRange();
    SetStreamsInfo;
    if(checkbox1.Checked) then
    begin
      tempoFX := xVideo_ChannelSetFX(chan,xVideo_FX_PITCHTEMPO);
    end;
    kar := xVideo_ChannelSetFX(chan,xVideo_FX_CHANMIX);
    xVideo_ChannelPlay(chan);
  end;

end;

procedure TFormPlayer.Button5Click(Sender: TObject);
begin
  xVideo_ChannelPlay(chan);
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
begin
  xVideo_ChannelPause(chan);
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
begin
  xVideo_ChannelStop(chan);
end;

procedure TFormPlayer.ComboBox1Change(Sender: TObject);
begin
 case combobox1.ItemIndex of
  0:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR7);
  1:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9);
  2:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR7WindowsLess);
  3:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
  4:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_EVR);
  5:  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_NULLVideo);
 end;
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
begin
 xVideo_Init(Handle,0);  // Init xVideo
 xVideo_SetConfig(xVideo_WindowLessHandle,Panel1.Handle);// set initial video renderer Handle

 
 xVideo_LoadPlugin(PChar('xVideo_MP3.dll'),{$IFDEF UNICODE}xVideo_UNICODE{$Else}0{$ENDIF});
 xVideo_LoadPlugin(PChar('xVideo_AAC.dll'),{$IFDEF UNICODE}xVideo_UNICODE{$Else}0{$ENDIF});
 xVideo_LoadPluginDS(PChar('{04FE9017-F873-410E-871E-AB91661A4EF7}'),PChar('FFDSHOW Video Decoder'),0);

 OcilloScope := TOcilloScope.Create(PaintFrame.Width, PaintFrame.Height);
 OcilloScope.Offset :=  100;
 Spectrum    := TSpectrum.Create(PaintFrame.Width, PaintFrame.Height);
 Spectrum.Mode := 1;
 Spectrum.Width := 3;
 Spectrum.Height := 90;
end;

procedure TFormPlayer.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
begin
  if ScrollCode = scEndScroll then
  begin
    xVideo_ChannelSetPosition(chan,sc.Position,xVideo_POS_SEC);
  end;
end;
procedure TFormPlayer.Filters1Click(Sender: TObject);
begin
  xVideo_ShowFilterPropertyPage(chan,popupmenu1.Items.Items[0].IndexOf(sender as Tmenuitem),handle);
end;

procedure TFormPlayer.Panel1DblClick(Sender: TObject);
begin
  if(VideoWindow.Visible = false)         then
  VideoWindow.show else VideoWindow.Close;
end;

procedure TFormPlayer.Timer1Timer(Sender: TObject);
var
 level: DWORD;
 FFTFata : TFFTData;
 WaveData  : TWaveData;
begin
 if(xVideo_ChannelGetState(chan) = xVideo_STATE_PLAYING)  then
 begin
  sc.Position:= round(xVideo_ChannelGetPosition(chan,xVideo_POS_SEC));
  label16.Caption := floattostr((xVideo_ChannelGetPosition(chan,xVideo_POS_FRAME)));
  if(Radiogroup1.ItemIndex = 0) then
  begin
   xVideo_ChannelGetData(Chan, @WaveData, 1024);
   OcilloScope.Draw (PaintFrame.Canvas.Handle, WaveData,0,PaintFrame.Height div 2);
  end else
  begin
    xVideo_ChannelGetData(Chan, @FFTFata,xVideo_DATA_FFT512);
    Spectrum.Draw (PaintFrame.Canvas.Handle,FFTFata,0, 0);
  end;
  level := xVideo_ChannelGetLevel(chan);
  progressbar1.Position := HIWORD(level);
  progressbar2.Position := LOWORD(level);
 end;
end;


procedure TFormPlayer.TrackBar1Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_VOL,trackbar1.Position);
end;

procedure TFormPlayer.TrackBar2Change(Sender: TObject);
var
 param: xVideoFX_TEMPO;
begin
 xVideo_GetFXParameters(chan,tempoFX,@param);
 param.pitch := trackbar2.Position;
 xVideo_SetFXParameters(chan,tempoFX,@param);
end;

procedure TFormPlayer.TrackBar3Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_PAN,trackbar3.Position/100);
end;

procedure TFormPlayer.TrackBar4Change(Sender: TObject);
begin
 xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_ALPHA,trackbar4.Position);
end;

procedure TFormPlayer.TrackBar5Change(Sender: TObject);
begin
  xVideo_ChannelSetAttribute(chan,xVideo_ATTRIB_RATE ,trackbar5.Position/100);
end;

procedure TFormPlayer.TrackBar6Change(Sender: TObject);
var
 param: xVideoFX_TEMPO;
begin
 xVideo_GetFXParameters(chan,tempoFX,@param);
 param.tempo := trackbar6.Position / 10;
 xVideo_SetFXParameters(chan,tempoFX,@param);
end;

procedure TFormPlayer.TrackBar7Change(Sender: TObject);
var
 param: xVideoFX_CHANNELMIX;
begin
 xVideo_GetFXParameters(chan,kar,@param);
 param.mode := trackbar7.Position;
 xVideo_SetFXParameters(chan,kar,@param);
end;

end.
