{
  xVideo 1.2: Delphi Mixing Videos Demo sample
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,xVideo, ComCtrls,ExtDlgs,
  XPMan, Menus;
  type
  TFormPlayer = class(TForm)
    sc: TScrollBar;
    Panel1: TPanel;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    XPManifest1: TXPManifest;
    OpenDialog: TOpenDialog;
    Button10: TButton;
    GroupBox1: TGroupBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    trtop: TTrackBar;
    trleft: TTrackBar;
    trright: TTrackBar;
    trbottom: TTrackBar;
    lblBrightness: TLabel;
    lblContrast: TLabel;
    lblHUE: TLabel;
    lblSaturation: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    AspectRatio1: TMenuItem;
    N431: TMenuItem;
    N1691: TMenuItem;
    procedure Button10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure trtopChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlayer : TFormPlayer;
  chan       : HSTREAM;
  chan2      : HSTREAM;
  rect1,rect2 : TRECT;
implementation

{$R *.dfm}

procedure TFormPlayer.Button10Click(Sender: TObject);
var
file1,file2: String;
begin
   OpenDialog.Title  := 'Open Files';
   OpenDialog.Filter := 'All files|*.*';
   begin
    xVideo_StreamFree(chan);
    xVideo_StreamFree(chan2);
    chan:=0;
    chan2 := 0;
   end;
   if not OpenDialog.Execute then exit;
   file1:=opendialog.FileName;
   if not OpenDialog.Execute then exit;
   file2:=opendialog.FileName;
   Chan := xVideo_StreamCreateFile(PChar(file1),0,Panel1.Handle,xVideo_STREAM_MIX);

   Chan2 := xVideo_StreamCreateFile(PChar(file2),0,Panel1.Handle,xVideo_STREAM_MIX);

   xVideo_ChannelPlay(chan);
   xVideo_ChannelPlay(chan2);
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
begin
 doublebuffered:=true;
 xVideo_Init(handle,0);
 xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
 xVideo_SetConfig(xVideo_WindowLessHandle,panel1.Handle);
 xVideo_SetConfig(xVideo_WindowLessStreams,2);
end;


procedure TFormPlayer.Button5Click(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 xVideo_ChannelPlay(H);
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 xVideo_ChannelPause(H);
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 xVideo_ChannelStop(H);
end;

procedure TFormPlayer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 xVideo_Free;
end;

procedure TFormPlayer.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 Sc.Max := round(xVideo_ChannelGetLength(H,xVideo_POS_SEC));
 xVideo_ChannelSetPosition(H,sc.position,xVideo_POS_SEC);
end;

procedure TFormPlayer.Timer1Timer(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 sc.Position:= round(xVideo_ChannelGetPosition(H,xVideo_POS_SEC));
end;

procedure TFormPlayer.TrackBar1Change(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 xVideo_SetVideoAlpha(H,0,0,TrackBar1.Position);
end;

procedure TFormPlayer.trtopChange(Sender: TObject);
var
 H: HSTREAM;
begin
 H := chan;
 if(combobox2.ItemIndex = 1)then H := chan2;
 rect1:=rect(trleft.Position,trtop.Position,trright.Position,trbottom.Position);
 xVideo_MIXChannelResize(H,combobox2.ItemIndex,rect1.Left,rect1.top,rect1.Right,rect1.Bottom);
end;

end.
