{
  xVideo 1.2: Delphi Mixing Videos Demo sample
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}
unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls, StdCtrls,xVideo, ComCtrls,ExtDlgs,
  XPMan, Menus;
  type
  TFormPlayer = class(TForm)
    sc: TScrollBar;
    Panel1: TPanel;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    XPManifest1: TXPManifest;
    OpenDialog: TOpenDialog;
    Button10: TButton;
    GroupBox1: TGroupBox;
    ComboBox2: TComboBox;
    Label1: TLabel;
    trtop: TTrackBar;
    trleft: TTrackBar;
    trright: TTrackBar;
    trbottom: TTrackBar;
    lblBrightness: TLabel;
    lblContrast: TLabel;
    lblHUE: TLabel;
    lblSaturation: TLabel;
    Label2: TLabel;
    TrackBar1: TTrackBar;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Filters1: TMenuItem;
    AspectRatio1: TMenuItem;
    N431: TMenuItem;
    N1691: TMenuItem;
    procedure Button10Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure trtopChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormPlayer : TFormPlayer;
  chan       : HSTREAM;
  paused: boolean;
  rect1,rect2 : TRECT;
implementation

{$R *.dfm}
function GetFiltersCallback(Filter : Pointer; FilterName: PCHAR;pp:BOOL;user:Pointer)  : BOOL; stdcall;
var
 item: TmenuItem;
begin
 item:= Tmenuitem.Create(FormPlayer.popupmenu1);
 item.Caption:=filtername;
 if pp=false then item.Enabled:=false;
 FormPlayer.PopupMenu1.Items.Items[0].Add(item);
 result:=true;
end;

procedure TFormPlayer.Button10Click(Sender: TObject);
var
file1,file2: String;
begin
   OpenDialog.Title  := 'Open Files';
   OpenDialog.Filter := 'All files|*.*';
   if chan<>0 then
   begin
    xVideo_StreamFree(chan);
    chan:=0;
   end;
   if not OpenDialog.Execute then exit;
   file1:=opendialog.FileName;
   if not OpenDialog.Execute then exit;
   file2:=opendialog.FileName;
   Chan := xVideo_StreamCreateFile(PChar(file1),0,Panel1.Handle,0);
   if chan<>0 then
   begin
    xVideo_ChannelAddFile(chan,Pchar(file2),0);
    xVideo_ChannelSetWindow(chan,0,panel1.Handle);

    sc.max:=round(xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
    timer1.Enabled:=true;
    Button5Click(Sender);
    xVideo_ChannelGetConnectedFilters(chan,@GetFiltersCallback,nil);
    trtopChange(Sender);
  end;
end;

procedure TFormPlayer.FormCreate(Sender: TObject);
begin
 paused:=false;
 doublebuffered:=true;
 xVideo_Init(handle,0);
 xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
 xVideo_SetConfig(xVideo_WindowLessHandle,panel1.Handle);
 xVideo_SetConfig(xVideo_WindowLessStreams,2);
end;


procedure TFormPlayer.Button5Click(Sender: TObject);
begin
 if(paused=true)then paused:=true;
 xVideo_ChannelPlay(chan);
end;

procedure TFormPlayer.Button6Click(Sender: TObject);
begin
 if(paused=false) then
 begin
  xVideo_ChannelPause(chan);
  paused:=true;
 end else
 begin
  xVideo_ChannelPlay(chan);
  paused:=false;
 end;
end;

procedure TFormPlayer.Button7Click(Sender: TObject);
begin
 xVideo_ChannelStop(chan);
end;

procedure TFormPlayer.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 xVideo_Free;
end;

procedure TFormPlayer.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
begin
 xVideo_ChannelSetPosition(chan,sc.position,xVideo_POS_SEC);
end;

procedure TFormPlayer.Timer1Timer(Sender: TObject);
begin
 if chan<>0 then
 sc.Position:= round(xVideo_ChannelGetPosition(chan,xVideo_POS_SEC));
end;

procedure TFormPlayer.TrackBar1Change(Sender: TObject);
begin
 xVideo_SetVideoAlpha(chan,0,combobox2.ItemIndex,TrackBar1.Position);
end;

procedure TFormPlayer.trtopChange(Sender: TObject);
begin
 rect1:=rect(trleft.Position,trtop.Position,trright.Position,trbottom.Position);
 xVideo_MIXChannelResize(chan,combobox2.ItemIndex,rect1.Left,rect1.top,rect1.Right,rect1.Bottom);
end;

end.
