{
  xVideo 1.2 Delphi Virtual Cam Output Example
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}


unit Unit3;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ExtCtrls,xVideo, StdCtrls, Menus, ComCtrls, jpeg;

type
  TForm3 = class(TForm)
    Panel1: TPanel;
    OpenDialog: TOpenDialog;
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    ComboBox1: TComboBox;
    Button3: TButton;
    GroupBox5: TGroupBox;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    sc: TScrollBar;
    Timer1: TTimer;
    procedure FormDestroy(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure scScroll(Sender: TObject; ScrollCode: TScrollCode; var ScrollPos:
        Integer);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form3: TForm3;
  chan: HSTREAM;
  asd : array of Integer;
  bmp: TBitmap;
  nr : Integer;
 bmpInfo : BITMAPINFO;
implementation

{$R *.dfm}

function GetVideoDevicesCallback(DevName: PChar;guid: TGUID;user: Pointer) : BOOL; stdcall;
begin
 if(Pos('Virtual Cam',DevName)=0) then    //we don't want the virtual Cam :)
  Form3.combobox1.Items.AddObject(DevName ,TOBject(nr));
  nr := nr + 1;
 // end;
  result := true;
end;
procedure TForm3.FormDestroy(Sender: TObject);
begin
 if chan<>0 then
 xVideo_StreamFree(chan);
end;
procedure TForm3.Button1Click(Sender: TObject);
var
 I: Integer;
begin
  OpenDialog.Title  := 'Open Files';
  OpenDialog.Filter := 'All files|*.*';
  if chan<>0 then
  begin
  xVideo_StreamFree(chan);
  chan:=0;
  end;
 if not OpenDialog.Execute then exit;
 Chan := xVideo_StreamCreateFile(PChar(OpenDialog.FileName),0,panel1.Handle,0);
 if chan<>0 then
 begin
  sc.Max :=round( xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
  xVideo_ChannelPlay(chan);
  xVideo_VCamStreamChannel(chan,true);
 end;
end;

procedure TForm3.Button2Click(Sender: TObject);
begin
 xVideo_VCamPush(Handle,asd);
end;

procedure TForm3.Button3Click(Sender: TObject);
begin
 if(chan<>0) then
 begin
  xVideo_StreamFree(chan);
  chan:=0;
 end;
 chan:=xVideo_CaptureCreate(0,integer(combobox1.Items.Objects[combobox1.ItemIndex]),0,0,0);
 if(chan<=0) then exit; //could not start record
 xVideo_ChannelSetWindow(chan,0,panel1.Handle);
 xVideo_ChannelPlay(chan);
 xVideo_VCamStreamChannel(chan,true);
end;

procedure TForm3.Button5Click(Sender: TObject);
begin
 xVideo_ChannelPlay(chan);
end;

procedure TForm3.Button6Click(Sender: TObject);
begin
 xVideo_ChannelPause(chan);
end;

procedure TForm3.Button7Click(Sender: TObject);
begin
 xVideo_ChannelStop(chan);
end;

procedure TForm3.FormCreate(Sender: TObject);
var
  I: Integer;
  bmp: TBitmap;
  J,P: Integer;

begin
  xVideo_Init(Panel1.Handle,0);
  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_VMR9WindowsLess);
  combobox1.Items.AddObject('None',TOBject(0));
  combobox1.ItemIndex := 0;
  nr := 1;
  xVideo_CaptureGetDevices(xVideo_CaptureVideo,@GetVideoDevicesCallback,nil);  //GetVideo Devices


  SetLength(asd,320*240*4);
  bmp:= TBitmap.Create;
  bmp.LoadFromFile('logo2.bmp');
  bmp.PixelFormat := pf32bit;
  // Copy the bitmap data into the provided BYTE buffer
  bmpInfo.bmiHeader.biCompression := BI_RGB;
  bmpInfo.bmiHeader.biBitCount    := 32;
	bmpInfo.bmiHeader.biSize       := sizeof(BITMAPINFOHEADER);
  bmpInfo.bmiHeader.biWidth      := 320;
  bmpInfo.bmiHeader.biHeight     := -240;
  bmpInfo.bmiHeader.biPlanes     := 1;
  bmpInfo.bmiHeader.biSizeImage  := 320 * 240 * 4;
  bmpInfo.bmiHeader.biClrImportant := 0;
  GetDIBits(bmp.Canvas.Handle, bmp.Handle, 0, 240, asd, bmpInfo , DIB_RGB_COLORS);
  timer1.Enabled := true;
end;

procedure TForm3.scScroll(Sender: TObject; ScrollCode: TScrollCode; var
    ScrollPos: Integer);
begin
 if ScrollCode = scEndScroll then
  begin
    xVideo_ChannelSetPosition(chan,sc.Position,xVideo_POS_SEC);
  end;
end;

procedure TForm3.Timer1Timer(Sender: TObject);
begin
 if(xVideo_ChannelGetState(chan) = xVideo_STATE_PLAYING)  then
 begin
  sc.Position:= round(xVideo_ChannelGetPosition(chan,xVideo_POS_SEC));
 end;
end;

end.
