
  
{
  xVideo 1.2 Delphi Wav Recording Example
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}


unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  xVideo, StdCtrls, ComCtrls, ExtCtrls,mmsystem, Menus;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Button1: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    OpenDialog1: TOpenDialog;
    ProgressBar1: TProgressBar;
    Label2: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  chan: DWORD;
  RecStream : TFileStream;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  xVideo_Init(handle,0);
  xVideo_SetConfig(xVideo_CONFIG_VideoRenderer,xVideo_NULLVideo);  //we don't want to show video... just decode the audio :D
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
 i: integer;
begin

  if(chan <> 0) then
  begin
   if(assigned(RecStream)) then
   begin
    i := RecStream.Size - 8;    // size of file
    RecStream.Position := 4;
    RecStream.write(i, 4);
    i := i - $24;               // size of data
    RecStream.Position := 40;
    RecStream.write(i, 4);
    RecStream.Free;
    RecStream:=nil;
   end;
  end;
  xVideo_Free();
end;


procedure TForm1.Button1Click(Sender: TObject);
var
 zChannels       : Word;   // number of channels (i.e. mono, stereo, etc.)
 zSamplesPerSec  : DWORD;  // sample rate
 zBitsPerSample  : Word;   // number of bits per sample of mono data
 chaninfo: xVideo_ChannelInfo;
 nBlockAlign , nAvgBytesPerSec: integer;

 buf : array [0..10000] of BYTE;
 BytesRead : integer;
 temp : String;
 dur : Int64;
 s : Int64;
 i: Integer;
begin
  if(chan<>0) then
  begin
    xVideo_StreamFree(chan); //free any existing free(if any)
  end;
  if(opendialog1.Execute() = false) then exit;

  //create a decoding stream
  chan := xVideo_StreamCreateFile(PChar(opendialog1.filename),0,0,xVideo_STREAM_DECODE);

  if(chan=0) then
  begin
    ShowMessage('The extracting can''t start');
    exit;
  end;

  xVideo_ChannelGetInfo(chan, @chaninfo);
  dur := round(chaninfo.nChannels * chaninfo.freq * chaninfo.wBits / 8 * xVideo_ChannelGetLength(chan,xVideo_POS_SEC));
 
  if(dur = 0) then ///we don't have audio or audio can't be decoded
  begin
    ShowMessage('Video don''t contain a valid audio stream. The decode will stop');
    xVideo_StreamFree(chan);//free the channel
    chan := 0;
  end;

	zChannels :=chaninfo.nChannels;
  zBitsPerSample := chaninfo.wBits;
  zSamplesPerSec :=chaninfo.freq;


 
  RecStream := TFileStream.Create(edit1.Text, fmCreate);
 // Write header portion of wave file
  temp := 'RIFF'; RecStream.write(temp[1], length(temp));
  temp := #0#0#0#0; RecStream.write(temp[1], length(temp));   // File size: to be updated
  temp := 'WAVE'; RecStream.write(temp[1], length(temp));
  temp := 'fmt '; RecStream.write(temp[1], length(temp));
  temp := #$10#0#0#0; RecStream.write(temp[1], length(temp)); // Fixed
  temp := #3#0; RecStream.write(temp[1], length(temp));       // PCM format
  if zChannels = 1 then
       temp := #1#0
  else
       temp := #2#0;
  RecStream.write(temp[1], length(temp));
  RecStream.write(zSamplesPerSec, 2);
  temp := #0#0; RecStream.write(temp[1], length(temp));   // SampleRate is given as dWord
  nBlockAlign := zChannels * zBitsPerSample div 8;
  nAvgBytesPerSec :=  zSamplesPerSec * nBlockAlign;
  RecStream.write(nAvgBytesPerSec, 4);
  RecStream.write(nBlockAlign, 2);
  RecStream.write(zBitsPerSample, 2);
  temp := 'data'; RecStream.write(temp[1],length(temp));
  temp := #0#0#0#0; RecStream.write(temp[1],length(temp)); // Data size: to be updated



  xVideo_ChannelPlay(chan);
  s := 0;

  BytesRead := xVideo_ChannelGetData(chan, @buf, 10000);
  while (BytesRead <> -1) do
  begin
      progressbar1.Position := round(s*100/dur);
      Label2.Caption := 'Encoding: '+ inttostr(progressbar1.Position)+'%';
      RecStream.Write(buf, BytesRead);
      Application.ProcessMessages;
      BytesRead := xVideo_ChannelGetData(chan, @buf, 10000);
      inc(s, BytesRead);
  end;
 Label2.Caption := 'Finished';
  
 if(chan<>0) then
 begin
   xVideo_ChannelStop(chan);
   xVideo_StreamFree(chan);
   chan := 0;
 end;

 if(assigned(RecStream)) then
 begin
    i := RecStream.Size - 8;    // size of file
    RecStream.Position := 4;
    RecStream.write(i, 4);
    i := i - $24;               // size of data
    RecStream.Position := 40;
    RecStream.write(i, 4);
    RecStream.Destroy;
    //RecStream.Free;
 end;
end;

end.
