
  
{
  xVideo 1.2 Delphi Wav Recording Example
  Copyright (c) 2010-2011 Cristea Aurel Ionut.
  Check http://surodev.com for updates
}


unit UnitMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  xVideo, StdCtrls, ComCtrls, ExtCtrls,mmsystem, Menus;

type
  TForm1 = class(TForm)
    GroupBox1: TGroupBox;
    Label4: TLabel;
    audiodev: TComboBox;
    Button1: TButton;
    Button2: TButton;
    Label1: TLabel;
    Edit1: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  PercentDone : Integer;
  CancelOp    : Boolean;
  chan: DWORD;
  dsp : HSTREAM;
  RecStream : TFileStream;

implementation

{$R *.dfm}
procedure MyDSP(handle: HDSP; channel: DWORD; buffer: Pointer; length: DWORD; user: Pointer); stdcall;
begin
   if(CancelOp=false) then
   RecStream.Write(buffer^, length);
   Form1.Caption := inttostr(length);
end;
function GetDevicesCallback(DevName: PChar;guid: TGUID;user: Pointer) : BOOL; stdcall;
begin
  Form1.audiodev.Items.Add(DevName);
  result:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  xVideo_Init(handle,0);
  xVideo_SetConfig(xVideo_CONFIG_AudioRenderer,xVideo_NULLAudio);

  audiodev.Items.Add('None');

  xVideo_CaptureGetDevices(xVideo_CaptureAudio,@GetDevicesCallback,nil);   //GetAudio Devices
 //we have at least a audio capture device
  if audiodev.Items.Count<>1 then  audiodev.ItemIndex:=1;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Button2Click(Sender);
  xVideo_Free();
end;


procedure TForm1.Button1Click(Sender: TObject);
var
 temp: string;
 zChannels       : Word;   // number of channels (i.e. mono, stereo, etc.)
 zSamplesPerSec  : DWORD;  // sample rate
 zBitsPerSample  : Word;   // number of bits per sample of mono data
 chaninfo: xVideo_ChannelInfo;
 OutFile : String;
 nBlockAlign , nAvgBytesPerSec: integer;
begin
  if(chan<>0) then
  begin
    xVideo_StreamFree(chan); //free any existing free(if any)
  end;
  chan := xVideo_CaptureCreate(audiodev.ItemIndex,0,0,0,0);
  if(chan=0) then
  begin
    ShowMessage('The record can''t start');
    exit;
  end;

  xVideo_ChannelGetInfo(chan, @chaninfo);

	zChannels :=chaninfo.nChannels;
  zBitsPerSample := chaninfo.wBits;
  zSamplesPerSec :=chaninfo.freq;


  OutFile := edit1.Text;
  RecStream := TFileStream.Create(OutFile, fmCreate);
 // Write header portion of wave file
  temp := 'RIFF'; RecStream.write(temp[1], length(temp));
  temp := #0#0#0#0; RecStream.write(temp[1], length(temp));   // File size: to be updated
  temp := 'WAVE'; RecStream.write(temp[1], length(temp));
  temp := 'fmt '; RecStream.write(temp[1], length(temp));
  temp := #$10#0#0#0; RecStream.write(temp[1], length(temp)); // Fixed
  temp := #1#0; RecStream.write(temp[1], length(temp));       // PCM format
  if zChannels = 1 then
       temp := #1#0
  else
       temp := #2#0;
  RecStream.write(temp[1], length(temp));
  RecStream.write(zSamplesPerSec, 2);
  temp := #0#0; RecStream.write(temp[1], length(temp));   // SampleRate is given as dWord
  nBlockAlign := zChannels * zBitsPerSample div 8;
  nAvgBytesPerSec :=  zSamplesPerSec * nBlockAlign;
  RecStream.write(nAvgBytesPerSec, 4);
  RecStream.write(nBlockAlign, 2);
  RecStream.write(zBitsPerSample, 2);
  temp := 'data'; RecStream.write(temp[1],length(temp));
  temp := #0#0#0#0; RecStream.write(temp[1],length(temp)); // Data size: to be updated

  dsp := xVideo_ChannelSetDSP(chan,@MyDSP,nil);


  xVideo_ChannelPlay(chan);

  Button2.Enabled := true;
  button1.Enabled := false;
end;

procedure TForm1.Button2Click(Sender: TObject);
 var
 I: integer;
begin
  if(chan<>0) then
  begin
  xVIdeo_ChannelRemoveDSP(chan,dsp);
   xVideo_ChannelStop(chan);
   xVideo_StreamFree(chan);
   chan := 0;
  end;


  if(assigned(RecStream)) then
   begin
   i := RecStream.Size - 8;    // size of file
   RecStream.Position := 4;
   RecStream.write(i, 4);
   i := i - $24;               // size of data
   RecStream.Position := 40;
   RecStream.write(i, 4);
   RecStream.Free;
   RecStream:=nil;
  end;
  button2.Enabled := false;
  button1.Enabled := true;
end;


end.
