unit test;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, StdCtrls,xVideo, ExtCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label5: TLabel;
    Label4: TLabel;
    Label6: TLabel;
    Panel1: TPanel;
    Label7: TLabel;
    TrackBar5: TTrackBar;
    Label8: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure TrackBar5Change(Sender: TObject);
  private
    { Private declarations }
    chan: HSTREAM;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  fx: array[1..6] of HFX;
  pR: xVideoFX_REVERB;
  p: xVideoFX_PARAMEQ;
  cc: xVideoFX_COMPRESSOR;
implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
   if(chan<>0) then
   begin
    xVideo_StreamFree(chan);
    chan := 0;
   end;
  if(OpenDialog1.Execute(Handle)=false) then exit;

   chan := xVideo_StreamCreateFile(PChar(OpenDialog1.Filename),0,panel1.Handle,{$IFDEF UNICODE}xVideo_UNICODE{$Else}0{$ENDIF});
   begin
    xVideo_ChannelSetWindow(chan,0,Panel1.Handle);
    fx[1] := xVideo_ChannelSetFX(chan,xVideo_FX_PARAMEQ);
    fx[2] := xVideo_ChannelSetFX(chan,xVideo_FX_PARAMEQ);
    fx[3] := xVideo_ChannelSetFX(chan,xVideo_FX_PARAMEQ);
    fx[4] := xVideo_ChannelSetFX(chan,xVideo_FX_REVERB);
    fx[5] := xVideo_ChannelSetFX(chan,xVideo_FX_COMPRESSOR);
    p.fGain := 0;
    p.fBandwidth := 18;
    p.fCenter := 80;
    xVideo_SetFXParameters(chan,fx[1], @p);
    p.fCenter := 1000;
    xVideo_SetFXParameters(chan,fx[2], @p);
    p.fCenter := 8000;
    xVideo_SetFXParameters(chan,fx[3], @p);

    xVideo_GetFXParameters(Chan,fx[4], @pR);
    pR.fReverbMix := -96;
    pR.fReverbTime := 1200;
    pR.fHighFreqRTRatio := 0.1;
    xVideo_SetFXParameters(Chan,fx[4], @pR);


    xVideo_ChannelPlay(chan);
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 xVideo_ChannelRemoveFX(chan,fx[4]);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 xVideo_Init(Handle,0);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
 xVideo_Free();
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
    xVideo_GetFXParameters(chan,fx[1], @p);
    p.fgain := 15-TrackBar1.position;
    xVideo_SetFXParameters(chan,fx[1], @p);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
   xVideo_GetFXParameters(chan,fx[2], @p);
    p.fgain := 15-TrackBar2.position;
    xVideo_SetFXParameters(chan,fx[2], @p);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
begin
    xVideo_GetFXParameters(chan,fx[3], @p);
    p.fgain := 15-TrackBar3.position;
    xVideo_SetFXParameters(chan,fx[3], @p);
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
var
    v: integer;
begin
    v := TrackBar4.position;
    xVideo_GetFXParameters(Chan,fx[4], @pR);
    // give exponential quality to trackbar as Bass more sensitive near 0
    pR.fReverbMix := -0.012*v*v*v; // gives -96 when bar at 20
    xVideo_SetFXParameters(Chan,fx[4], @pR);
    Label5.Caption := inttostr(20-TrackBar4.position);
end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
    xVideo_GetFXParameters(Chan,fx[5], @cc);
    cc.fGain := -TrackBar5.Position ;
    xVideo_SetFXParameters(Chan,fx[5], @cc);
    label8.Caption := inttostr(round(cc.fGain))+'dB';
end;

end.
