﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using xVideo;

namespace Demo
{
    public partial class Form1 : Form
    {   
        
        Player mPlayer = new Player();
         
        public Form1()
        {
            InitializeComponent();
        }
        private string GetClipFileName()
        {
            if (openFileDialog1.ShowDialog() == DialogResult.OK)
            {
                return openFileDialog1.FileName;
            }
            else
                return string.Empty;
        }
        private void SetVideoInfo()
        {
            xVideo.xVideo_ChannelInfo info = mPlayer.GetInfo(0);
            label6.Text = info.Width.ToString();
            label7.Text = info.Height.ToString();
            label9.Text = info.nChannels.ToString();
            label11.Text = info.wBits.ToString();
            label13.Text = info.freq.ToString();

            listBox1.Items.Clear();
            int filterNr = mPlayer.GetFilterCount();
            for (int i = 0; i <= filterNr; i++)
                listBox1.Items.Add(mPlayer.GetFilterName(i));

        }
        private void SetStreamsInfo()
        {
            int count = (int)mPlayer.GetStreamsCount();
            for (int i = 0; i < count; i++)
            {
                xVideo_STREAMS str = mPlayer.GetStreamInfo(i);
                listBox2.Items.Add(str.name);

            }
        }
        private void Form1_Load(object sender, EventArgs e)
        {
            Functions.xVideo_Init(Handle, 0); //Initialize xVideo :)
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string str = GetClipFileName();

            if (mPlayer.RenderFile(str, panel1.Handle, false, false))
            {
                mPlayer.SetWindow(panel1.Handle);
                Position.Maximum = (Int32)(mPlayer.Duration(xVideo_Position_Modes.xVideo_POS_SEC));
                SetVideoInfo();
                SetStreamsInfo();
                mPlayer.Play();
            }
        }

        private void button2_Click(object sender, EventArgs e)
        {
            mPlayer.Play();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            mPlayer.Pause();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            mPlayer.Stop();
        }

        private void Position_Scroll(object sender, EventArgs e)
        {
            mPlayer.SetPosition((double)Position.Value, xVideo_Position_Modes.xVideo_POS_SEC);
        }

        private void trackBar1_Scroll(object sender, EventArgs e)
        {
            mPlayer.SetVolume(trackBar1.Value);
        }

        private void trackBar4_Scroll(object sender, EventArgs e)
        {
            mPlayer.SetVideoAlpha(trackBar4.Value/100.0f);
        }

        private void trackBar6_Scroll(object sender, EventArgs e)
        {
            mPlayer.SetPan(trackBar6.Value);
        }

        private void trackBar7_Scroll(object sender, EventArgs e)
        {
            mPlayer.SetRate(trackBar7.Value / 100.0f);
        }

        private void listBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            mPlayer.ShowProperyPage(listBox1.SelectedIndex, Handle);
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        { 
             
        }
    }
}
