Attribute VB_Name = "modSpectrum"
 

Option Explicit

Public Const BI_RGB = 0&
Public Const DIB_RGB_COLORS = 0&    ' color table in RGBs

Public Type BITMAPINFOHEADER
        biSize As Long
        biWidth As Long
        biHeight As Long
        biPlanes As Integer
        biBitCount As Integer
        biCompression As Long
        biSizeImage As Long
        biXPelsPerMeter As Long
        biYPelsPerMeter As Long
        biClrUsed As Long
        biClrImportant As Long
End Type

Public Type RGBQUAD
        rgbBlue As Byte
        rgbGreen As Byte
        rgbRed As Byte
        rgbReserved As Byte
End Type

Public Type BITMAPINFO
        bmiHeader As BITMAPINFOHEADER
        bmiColors(255) As RGBQUAD
End Type

Declare Sub FillMemory Lib "kernel32.dll" Alias "RtlFillMemory" (Destination As Any, ByVal length As Long, ByVal Fill As Byte)
Public Declare Function SetDIBitsToDevice Lib "gdi32" (ByVal hDC As Long, ByVal X As Long, ByVal Y As Long, ByVal dx As Long, ByVal dy As Long, ByVal SrcX As Long, ByVal SrcY As Long, ByVal Scan As Long, ByVal NumScans As Long, Bits As Any, BitsInfo As BITMAPINFO, ByVal wUsage As Long) As Long

' NOTE: Using an API MM timer (may sometimes Crash your app in an IDE mode)
Public Const TIME_PERIODIC = 1  ' program for continuous periodic event
Public Declare Function timeSetEvent Lib "winmm.dll" (ByVal uDelay As Long, ByVal uResolution As Long, ByVal lpFunction As Long, ByVal dwUser As Long, ByVal uFlags As Long) As Long
Public Declare Function timeKillEvent Lib "winmm.dll" (ByVal uID As Long) As Long
Public timing As Long       ' an API timer Handle

Public Const SPECWIDTH As Long = 368  ' display width
Public Const SPECHEIGHT As Long = 127 ' height (changing requires palette adjustments too)

Public chan As Long         ' stream/music handle

Public specpos As Long   ' spectrum mode (and marker pos for 2nd mode)
Public specbuf() As Byte    ' a pointer
Public mode As Long
Public bh As BITMAPINFO     ' bitmap header

' MATH Functions
Public Function Sqrt(ByVal num As Double) As Double
    Sqrt = num ^ 0.5
End Function

Function Log10(ByVal X As Double) As Double
    Log10 = Log(X) / Log(10#)
End Function

' update the spectrum display - the interesting bit :)
Public Sub UpdateSpectrum(ByVal uTimerID As Long, ByVal uMsg As Long, ByVal dwUser As Long, ByVal dw1 As Long, ByVal dw2 As Long)
       Dim X As Long, Y As Long, y1 As Long
    
        Dim c As Long, buf() As Single, ci As xVideo_ChannelInfo
        ReDim specbuf(SPECWIDTH * (SPECHEIGHT + 1)) As Byte ' clear display
If (mode = 0) Then
        Call xVideo_ChannelGetInfo(chan, ci) ' get number of channels
        ReDim buf(ci.nChannels * SPECWIDTH * LenB(buf(0))) As Single  ' allocate buffer for data

        Call xVideo_ChannelGetData(chan, buf(0), (ci.nChannels * SPECWIDTH * LenB(buf(0))) Or xVideo_DATA_FLOAT)  ' get the sample data (floating-point to avoid 8 & 16 bit processing)
        For c = 0 To ci.nChannels - 1
            For X = 0 To SPECWIDTH - 1
                Dim v As Long
                v = (1 - buf(X * ci.nChannels + c)) * SPECHEIGHT / 2 ' invert and scale to fit display
                If (v < 0) Then
                    v = 0
                ElseIf (v >= SPECHEIGHT) Then
                    v = SPECHEIGHT - 1
                End If
                If (X = 0) Then Y = v
                Do  ' draw line from previous sample...
                    If (Y < v) Then
                        Y = Y + 1
                    ElseIf (Y > v) Then
                        Y = Y - 1
                    End If
                    specbuf(Y * SPECWIDTH + X) = IIf(c And 1, 127, 1) ' left=green, right=red (could add more colours to palette for more chans)
                Loop While (Y <> v)
            Next X
        Next c
     End If
    If (mode = 1) Then
           Dim fft(1024) As Single     ' get the FFT data
        Call xVideo_ChannelGetData(chan, fft(0), xVideo_DATA_FFT512)

     
            ReDim specbuf(SPECWIDTH * (SPECHEIGHT + 1)) As Byte ' clear display
            For X = 0 To (SPECWIDTH / 2) - 1
#If 1 Then
                Y = (fft(X + 1))       ' scale it (sqrt to make low values more visible)
#Else
                Y = fft(X + 1)    ' scale it (linearly)
#End If
                If (Y > SPECHEIGHT) Then Y = SPECHEIGHT ' cap it
                If (X) Then  ' interpolate from previous to make the display smoother
                    y1 = (Y + y1) / 2
                    y1 = y1 - 1
                    While (y1 >= 0)
                        specbuf(y1 * SPECWIDTH + X * 2 - 1) = y1 + 1
                        y1 = y1 - 1
                    Wend
                End If
                y1 = Y
                Y = Y - 1
                While (Y >= 0)
                    specbuf(Y * SPECWIDTH + X * 2) = Y + 1 ' draw level
                    Y = Y - 1
                Wend
            Next X
            End If

    ' update the display
    ' to display in a PictureBox, simply change the .hDC to Picture1.hDC :)
    Call SetDIBitsToDevice(frmSpectrum.hDC, 0, 0, SPECWIDTH, SPECHEIGHT, 0, 0, 0, SPECHEIGHT, specbuf(0), bh, 0)
End Sub
