Attribute VB_Name = "Module1"

' xVideo 1.2.1 Visual Basic module
' Copyright (c) 2010-2011 Cristea Aurel Ionut
'
' See the xVideo.CHM file for more detailed documentation

' NOTE: VB does not support 64-bit integers, so VB users only have access
'       to the low 32-bits of 64-bit return values. 64-bit parameters can
'       be specified though, using the "64" version of the function.

' NOTE: Use "StrPtr(filename)" to pass a filename to the xVideo_StreamCreateXXX when needed.

' NOTE: Use the VBStrFromAnsiPtr function to convert "char *" to VB "String".

Global Const xVideoVERSION = &H102    'API version
Global Const xVideoVERSIONTEXT = "1.2"




'xVideo_Init Flags
Global Const xVideo_MultiThread = &H10 'enable multithread support


 
'Stream Creation Flags
Global Const xVideo_UNICODE = &H80000000              'pass this flag when use UNICODE strings
Global Const xVideo_STREAM_AUTOFREE = &H40000         'put this flag to free the stream when it completes
Global Const xVideo_STREAM_DECODE = &H200000          'put this flag to set the channnel as a encoding one
Global Const xVideo_STREAM_MIX = &H20000              'put this flag to enable channel video mixer

'xVideo_CaptureXXX functions flags
Global Const xVideo_CaptureAudio = &H10066
Global Const xVideo_CaptureVideo = &H10080


'xVideo_ChannelGetState return values
Global Const xVideo_STATE_PLAYING = 1       'channel is playing
Global Const xVideo_STATE_PAUSED = 2        'channel is paused
Global Const xVideo_STATE_STOPPED = 3      'channel is stopped
  

'xVideo_ChannelGetLenght/SetPosition/GetPosition: modes
Global Const xVideo_POS_SEC = 0                   'position in seconds
Global Const xVideo_POS_FRAME = 1                 'position in frames
Global Const xVideo_POS_MILISEC = 2               'position in miliseconds
Global Const xVideo_POS_REFTIME = 3               'position in reference time

'xVideo_ChannelSetAttribute/GetAttribute Constants
Global Const xVideo_ATTRIB_VOL = 1             'used to set Audio Volume
Global Const xVideo_ATTRIB_PAN = 2             'used to set Audio Pan
Global Const xVideo_ATTRIB_RATE = 3            'used to set Graph Rate
Global Const xVideo_ATTRIB_ALPHA = 4           'use this to set main video alpha blend value

'FX effect types, use with xVideo_ChannelSetFX
Global Const xVideo_FX_REVERB = 1
Global Const xVideo_FX_PARAMEQ = 2
Global Const xVideo_FX_CHORUS = 3
Global Const xVideo_FX_COMPRESSOR = 4
Global Const xVideo_FX_ECHO = 5
Global Const xVideo_FX_FLANGER = 6
Global Const xVideo_FX_PITCHTEMPO = 7
Global Const xVideo_FX_CHANMIX = 8


'xVideo_SetConfig configs and values
Global Const xVideo_CONFIG_VideoRenderer = &H1000
Global Const xVideo_VMR7 = 1                              'pass this to select VMR7 Windowed render
Global Const xVideo_VMR9 = 2                              'pass this to select VMR9 Windowed render
Global Const xVideo_VMR7WindowsLess = 3                    'pass this to select VMR7 window less render
Global Const xVideo_VMR9WindowsLess = 4                    'pass this to select VMR9 window less render
Global Const xVideo_EVR = 5                                'pass this to select Enhanced Video Renderer
Global Const xVideo_NULLVideo = 6                          'pass this to select NULL Video Renderer
Global Const xVideo_WindowLessStreams = &H1002              'use this to set the number of streams in a VMR7/9 Windowsless mode
Global Const xVideo_WindowLessHandle = &H1001               'VMR7/VMR9 WindowLess Mode need an initial window so set a HWND to use properly VMR
Global Const xVideo_CONFIG_AudioRenderer = &H1004    'use this to select audio renderer
Global Const xVideo_NULLAudio = &H1432               'use this to select NULL Audio Renderer
Global Const xVideo_DefaultAudio = &H1433            'use this to select Windows Default Audio Device
Global Const xVideo_CONFIG_FLOATDSP = &H1005         'use this to enable/disable floating point processing DSP



'''Color Controls FLAGS''''''''''''''
Global Const xVideo_ControlBrightness = &H1
Global Const xVideo_ControlContrast = &H2
Global Const xVideo_ControlHue = &H4
Global Const xVideo_ControlSaturation = &H8

'xVideo_ChannelGetData Flags
Global Const xVideo_DATA_END = &H80000000  ' end of file
Global Const xVideo_DATA_FLOAT = &H40000000    ' flag: return floating-point sample data
Global Const xVideo_DATA_FFT512 = &H10000000      'flag: return FFT 512

'xVideo_EncodeXXX functions flags
Global Const xVideo_AudioEncoder = &H10366
Global Const xVideo_VideoEncoder = &H10380
Global Const xVideo_EncodeAVI = &H10013
Global Const xVideo_EncodeWMV = &H10014
Global Const xVideo_EncodeMUXER = &H10015

'xVideo Error Codes

Global Const xVideo_OK = 0                     'all ok
Global Const xVideo_INVALIDCHAN = 1            'invalid channel was specified
Global Const xVideo_UNKNOWN = 2                'unknown error
Global Const xVideo_NotInitialized = 3         'xVideo is not initialized
Global Const xVideo_POSNOTAVAILABLE = 4        'the specified position mode is not available
Global Const xVideo_NODSHOW = 5                'no Directshow framework available
Global Const xVideo_INVALIDWINDOW = 6         'invalid window handle specified
Global Const xVideo_NOAUDIO = 7                'no audio available in channel
Global Const xVideo_NOVIDEO = 8                'no video available in channel
Global Const xVideo_ERRORMEM = 9               'no memory available
Global Const xVideo_ERRORCALLBACK = 10         'the callback function is NULL
Global Const xVideo_ERRORFLAG = 11             'invalid flag was specified
Global Const xVideo_NOTAVAILABLE = 12          'this function is not available
Global Const xVideo_ERRORINIT = 13             'failed to initialize xVideo

'for xVideo_ChannelGetInfo function
Type xVideo_ChannelInfo
     AvgTimePerFrame As Single 'average Time per frame (i.e 23.97 - it will draw 23.97 frames per seconds)
     Height As Long  'video size
     Width As Long  'video size
     nChannels As Long  'number of channels (i.e.1= mono,2= stereo...)
     freq As Long  'sample rate
     wBits As Long  'number of bits per sample of mono data */
     floatingpoint As Long  'true if audio is 32 bit floating point, false else
End Type


'for Video BMP functions
Type xVideo_VideoBitmap
    visible As Long       '0(zero) to hide bitmap, 1(one) to show it
    inLeft As Long        'bitmap in Left
    inTop  As Long        'bitmap in Top
    inRight As Long       'bitmap in Right
    inBottom As Long      'bitmap in Bottom
    outLeft As Single     'bitmap out Left (0 ... 1.0)
    outTop  As Single     'bitmap out Top (0 ... 1.0)
    outRight As Single    'bitmap out right (0 ... 1.0)
    outBottom As Single   'bitmap out Bottom (0 ... 1.0)
    alphavalue As Single  'bitmap alpha blend value (0 ... 1.0)
    transcolor As Long    'bitmap transparent color
    bmp As Long
End Type


Type xVideoFX_PARAMEQ
    fCenter As Single
    fBandwidth As Single
    fGain As Single
End Type

Type xVideoFX_TEMPO
    Tempo As Single
    Pitch As Single
    tempoRate As Single
End Type

Type xVideoFX_CHANNELMIX
   mode As Long 'xVideo_CHANMIX_xxx
End Type

Type xVideoFX_REVERB
    fInGain As Single              '[-96.0,0.0]            default: 0.0 dB
    fReverbMix As Single           '[-96.0,0.0]            default: 0.0 db
    fReverbTime As Single          '[0.001,3000.0]         default: 1000.0 ms
    fHighFreqRTRatio As Single     '[0.001,0.999]          default: 0.001
End Type

Type xVideoFX_FLANGER
    fWetDryMix As Single
    fDepth As Single
    fFeedback As Single
    fFrequency As Single
    lWaveform As Single
    fDelay As Single
    lPhase As Single
End Type

Type xVideoFX_CHORUS
    fWetDryMix  As Single
    fDepth  As Single
    fFeedback  As Single
    fFrequency  As Single
    lWaveform  As Long '0=triangle, 1=sine
    fDelay  As Single
    lPhase  As Long   'xVideo_PHASE_xxx
End Type



Type xVideoFX_COMPRESSOR
    fGain As Single
    fAttack As Single
    fRelease As Single
    fThreshold As Single
    fRatio As Single
    fPredelay As Single
End Type

Type xVideoFX_ECHO
    fWetDryMix As Single
    fFeedback As Single
    fLeftDelay As Single
    fRightDelay As Single
    lPanDelay As Long
End Type

'for xVideo_ChannelColorRange function''
Type xVideo_ColorsRange
    MinValue     As Single
    MaxValue     As Single
    DefaultValue As Single
    StepSize     As Single
    typ          As Long 'one of the xVideo_ControlXXX
End Type
'for xVideo_ChannelSetColors function''
Type xVideo_ColorsSet
     Contrast    As Single
     Brightness  As Single
     Hue         As Single
     Saturation  As Single
End Type






'xVideo Functions

Declare Function xVideo_ErrorGetCode Lib "xVideo.dll" () As Long
Declare Function xVideo_GetVersion Lib "xVideo.dll" () As Long
Declare Function xVideo_Init Lib "xVideo.dll" (ByVal win As Long, ByVal flags As Long) As Long
Declare Function xVideo_StreamCreateFile Lib "xVideo.dll" (ByVal file As Any, ByVal pos As Long, ByVal win As Long, ByVal flags As Long) As Long
Declare Function xVideo_ChannelPlay Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_ChannelPause Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_ChannelStop Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_StreamFree Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_ChannelSetWindow Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long, ByVal win As Long) As Long
Declare Function xVideo_ChannelSetPosition Lib "xVideo.dll" (ByVal chan As Long, ByVal position As Single, ByVal mode As Long) As Long
Declare Function xVideo_ChannelSetPosition64 Lib "xVideo.dll" Alias "xVideo_ChannelSetPositionVB" (ByVal handle As Long, ByVal pos As Long, ByVal poshigh As Long, ByVal mode As Long) As Long

Declare Function xVideo_ChannelGetLength Lib "xVideo.dll" (ByVal chan As Long, ByVal mode As Long) As Single
Declare Function xVideo_ChannelGetPosition Lib "xVideo.dll" (ByVal chan As Long, ByVal mode As Long) As Single
Declare Function xVideo_ChannelGetConnectedFilters Lib "xVideo.dll" (ByVal chan As Long, ByVal callback As Long, ByVal user As Any) As Long
Declare Function xVideo_GetGraph Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_ChannelGetState Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_ChannelResizeWindow Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long, ByVal left As Long, ByVal top As Long, ByVal right As Long, ByVal bottom As Long) As Long
Declare Function xVideo_ChannelSetFullscreen Lib "xVideo.dll" (ByVal chan As Long, ByVal value As Long) As Long
Declare Function xVideo_ShowFilterPropertyPage Lib "xVideo.dll" (ByVal chan As Long, ByVal filter As Long, ByVal HwndParent As Long) As Long
Declare Function xVideo_Free Lib "xVideo.dll" () As Long
Declare Function xVideo_ChannelAddWindow Lib "xVideo.dll" (ByVal chan As Long, ByVal Hwnd As Long) As Long
Declare Function xVideo_ChannelRemoveWindow Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long) As Long
Declare Function xVideo_ChannelRepaint Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long, ByVal dc As Long) As Long
Declare Function xVideo_ChannelSetAttribute Lib "xVideo.dll" (ByVal chan As Long, ByVal opt As Long, ByVal value As Single) As Long
Declare Function xVideo_ChannelGetAttribute Lib "xVideo.dll" (ByVal chan As Long, ByVal opt As Long) As Single
Declare Function xVideo_SetConfig Lib "xVideo.dll" (ByVal config As Long, ByVal value As Long) As Long
Declare Function xVideo_SetVideoAlpha Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long, ByVal layer As Long, ByVal value As Single) As Long
Declare Function xVideo_GetVideoAlpha Lib "xVideo.dll" (ByVal chan As Long, ByVal hWindow As Long, ByVal layer As Long) As Single
Declare Function xVideo_ChannelAddFile Lib "xVideo.dll" (ByVal chan As Long, ByVal file As Any, ByVal flags As Long) As Long
Declare Function xVideo_ChannelGetInfo Lib "xVideo.dll" (ByVal handle As Long, ByRef info As xVideo_ChannelInfo) As Long
Declare Function xVideo_ChannelOverlayBMP Lib "xVideo.dll" (ByVal handle As Long, ByRef info As xVideo_VideoBitmap) As Long

Declare Function xVideo_CaptureGetDevices Lib "xVideo.dll" (ByVal devicetype As Long, ByRef callback As Any, ByRef user As Any) As Long
Declare Function xVideo_CaptureFree Lib "xVideo.dll" (ByVal chan As Long) As Long
Declare Function xVideo_CaptureCreate Lib "xVideo.dll" (ByVal audio As Long, ByVal video As Long, ByVal audioprofile As Long, ByVal videoprofile As Long, ByVal flags As Long) As Long
Declare Function xVideo_CaptureDeviceProfiles Lib "xVideo.dll" (ByVal device As Long, ByRef callback As Any, ByRef user As Any) As Long

Declare Function xVideo_DVDGetProperty Lib "xVideo.dll" (ByVal chan As Long, ByVal prop As Long, ByVal value As Long) As Long
Declare Function xVideo_DVDSetProperty Lib "xVideo.dll" (ByVal chan As Long, ByVal prop As Long, ByVal value As Long) As Long
Declare Function xVideo_DVDChannelMenu Lib "xVideo.dll" (ByVal chan As Long, ByVal value1 As Long, ByVal value2 As Long) As Long
 
 
 
Declare Function xVideo_MIXChannelResize Lib "xVideo.dll" (ByVal chan As Long, ByVal layer As Long, ByVal left As Long, ByVal top As Long, ByVal right As Long, ByVal bottom As Long) As Long
Declare Function xVideo_ChannelGetBitmap Lib "xVideo.dll" (ByVal handle As Long) As Long
Declare Function xVideo_ChannelColorRange Lib "xVideo.dll" (ByVal handle As Long, ByVal id As Long, ByRef str As xVideo_ColorsRange) As Long
Declare Function xVideo_ChannelSetColors Lib "xVideo.dll" (ByVal handle As Long, ByVal id As Long, ByRef str As xVideo_ColorsSet) As Long
   
Declare Function xVideo_StreamCreateFileUser Lib "xVideo.dll" (ByVal flags As Long, ByVal win As Long, ByVal procs As Long, ByVal user As Long) As Long
Declare Function xVideo_StreamCreateFileMem Lib "xVideo.dll" (ByVal data As Any, ByVal size As Long, ByVal win As Long, ByVal flags As Long) As Long

Declare Function xVideo_ChannelSetFX Lib "xVideo.dll" (ByVal handle As Long, ByVal fx As Long) As Long
Declare Function xVideo_ChannelRemoveFX Lib "xVideo.dll" (ByVal handle As Long, ByVal hFX As Long) As Long
Declare Function xVideo_SetFXParameters Lib "xVideo.dll" (ByVal handle As Long, ByVal hFX As Long, ByRef par As Any) As Long
Declare Function xVideo_GetFXParameters Lib "xVideo.dll" (ByVal handle As Long, ByVal hFX As Long, ByRef par As Any) As Long
   
Declare Function xVideo_ChannelSetDSP Lib "xVideo.dll" (ByVal handle As Long, ByVal proc As Long, ByVal user As Any) As Long
Declare Function xVideo_ChannelRemoveDSP Lib "xVideo.dll" (ByVal handle As Long, ByVal hDSP As Long) As Long

Declare Function xVideo_ChannelGetData Lib "xVideo.dll" (ByVal handle As Long, ByRef buf As Any, ByVal size As Long) As Long
Declare Function xVideo_ChannelGetLevel Lib "xVideo.dll" (ByVal handle As Long) As Long


Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (ByRef Destination As Any, ByRef Source As Any, ByVal length As Long)
Private Declare Function lstrlen Lib "kernel32" Alias "lstrlenA" (ByVal lpString As Long) As Long
 

Type xVideo_FILEPROCS
    close As Long
    length As Long
    read As Long
    seek As Long
End Type

' User file stream callback functions (xVideo_FILEPROCS)
Sub FILECLOSEPROC(ByVal user As Long)

End Sub

Function FILELENPROC(ByVal user As Long) As Currency ' ???

End Function

Function FILEREADPROC(ByVal buffer As Long, ByVal length As Long, ByVal user As Long) As Long

End Function

Function FILESEEKPROC(ByVal offset As Long, ByVal offsethigh As Long, ByVal user As Long) As Long

End Function


Public Function LoByte(ByVal lparam As Long) As Long
LoByte = lparam And &HFF&
End Function
Public Function HiByte(ByVal lparam As Long) As Long
HiByte = (lparam And &HFF00&) / &H100&
End Function
Public Function LoWord(ByVal lparam As Long) As Long
LoWord = lparam And &HFFFF&
End Function
Public Function HiWord(ByVal lparam As Long) As Long
If lparam < 0 Then
    HiWord = (lparam \ &H10000 - 1) And &HFFFF&
Else
    HiWord = lparam \ &H10000
End If
End Function
Function MakeWord(ByVal LoByte As Long, ByVal HiByte As Long) As Long
MakeWord = (LoByte And &HFF&) Or ((HiByte And &HFF&) * &H100&)
End Function
Function MakeLong(ByVal LoWord As Long, ByVal HiWord As Long) As Long
MakeLong = LoWord And &HFFFF&
HiWord = HiWord And &HFFFF&
If HiWord And &H8000& Then
    MakeLong = MakeLong Or (((HiWord And &H7FFF&) * &H10000) Or &H80000000)
Else
    MakeLong = MakeLong Or (HiWord * &H10000)
End If
End Function

Public Function VBStrFromAnsiPtr(ByVal lpStr As Long) As String
Dim bStr() As Byte
Dim cChars As Long
On Error Resume Next
' Get the number of characters in the buffer
cChars = lstrlen(lpStr)
If cChars Then
    ' Resize the byte array
    ReDim bStr(0 To cChars - 1) As Byte
    ' Grab the ANSI buffer
    Call CopyMemory(bStr(0), ByVal lpStr, cChars)
End If
' Now convert to a VB Unicode string
VBStrFromAnsiPtr = StrConv(bStr, vbUnicode)
End Function
Function xVideo_ChannelSetPositionVB(ByVal handle As Long, ByVal pos As Long, ByVal mode As Long) As Long
xVideo_ChannelSetPositionVB = xVideo_ChannelSetPosition64(handle, pos, 0, mode)
End Function


